Subject: Re: [PATCH net-next v4] bridge: multicast to unicast

From: Stephen Hemminger <[email-masked]>
Date: Thu, 19 Jan 2017 11:05:20 -0800

On Thu, 19 Jan 2017 03:45:10 +0100
Linus Lüssing <[email-masked]> wrote:

> From: Felix Fietkau <[email-masked]>
> 
> Implements an optional, per bridge port flag and feature to deliver
> multicast packets to any host on the according port via unicast
> individually. This is done by copying the packet per host and
> changing the multicast destination MAC to a unicast one accordingly.
> 
> multicast-to-unicast works on top of the multicast snooping feature of
> the bridge. Which means unicast copies are only delivered to hosts which
> are interested in it and signalized this via IGMP/MLD reports
> previously.
> 
> This feature is intended for interface types which have a more reliable
> and/or efficient way to deliver unicast packets than broadcast ones
> (e.g. wifi).
> 
> However, it should only be enabled on interfaces where no IGMPv2/MLDv1
> report suppression takes place. This feature is disabled by default.
> 
> The initial patch and idea is from Felix Fietkau.
> 
> Signed-off-by: Felix Fietkau <[email-masked]>
> [[email-masked]: various bug + style fixes, commit message]
> Signed-off-by: Linus Lüssing <[email-masked]>
> 

In general this looks good.

One issue I see is how existing entries are handled when the bridge port flags
are changed dynamically. It might be better to always record the necessary data
in the bridge_port_group and not have a per-entry flag bit. In your current
patch the API changes the response to future IGMP but does not take instant
effect. Code would be simpler if there was less logic to handle per-entry flags.

Also, you might want to add sysfs interface for the attribute as well.